diff --git a/envelope.c b/envelope.c
index 88d2f280b9..d7ce4cfd7b 100644
--- a/envelope.c
+++ b/envelope.c
@@ -86,7 +86,11 @@ void mutt_free_envelope(struct Envelope **p)
   FREE(&(*p)->x_comment_to);
 #endif
 
-  mutt_buffer_free(&(*p)->spam);
+  if ((*p)->spam)
+  {
+    mutt_buffer_deinit((*p)->spam);
+    FREE(&(*p)->spam);
+  }
 
   mutt_list_free(&(*p)->references);
   mutt_list_free(&(*p)->in_reply_to);
@@ -155,7 +159,11 @@ void mutt_merge_envelopes(struct Envelope *base, struct Envelope **extra)
   }
   /* spam and user headers should never be hashed, and the new envelope may
     * have better values. Use new versions regardless. */
-  mutt_buffer_free(&base->spam);
+  if (base->spam)
+  {
+    mutt_buffer_deinit(base->spam);
+    FREE(&base->spam);
+  }
   mutt_list_free(&base->userhdrs);
   MOVE_ELEM(spam);
   MOVE_STAILQ(userhdrs);
diff --git a/mutt/buffer.c b/mutt/buffer.c
index bbeb970739..3eafd7470a 100644
--- a/mutt/buffer.c
+++ b/mutt/buffer.c
@@ -31,7 +31,6 @@
  * | mutt_buffer_add()    | Add a string to a Buffer, expanding it if necessary
  * | mutt_buffer_addch()  | Add a single character to a Buffer
  * | mutt_buffer_addstr() | Add a string to a Buffer
- * | mutt_buffer_free()   | Release a Buffer and its contents
  * | mutt_buffer_from()   | Initialize a Buffer from an existing string
  * | mutt_buffer_init()   | Initialise a new Buffer
  * | mutt_buffer_deinit() | Release the memory allocated by a Buffer
@@ -125,20 +124,6 @@ static void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len)
   *(buf->dptr) = '\0';
 }
 
-/**
- * mutt_buffer_free - Release a Buffer and its contents
- * @param p Buffer pointer to free and NULL
- */
-void mutt_buffer_free(struct Buffer **p)
-{
-  if (!p || !*p)
-    return;
-
-  mutt_buffer_deinit(*p);
-  /* dptr is just an offset to data and shouldn't be freed */
-  FREE(p);
-}
-
 /**
  * mutt_buffer_printf - Format a string into a Buffer
  * @param buf Buffer
diff --git a/mutt/buffer.h b/mutt/buffer.h
index 8d340ffd90..6dcfe711a6 100644
--- a/mutt/buffer.h
+++ b/mutt/buffer.h
@@ -41,7 +41,6 @@ struct Buffer
 
 void mutt_buffer_addch(struct Buffer *buf, char c);
 void mutt_buffer_addstr(struct Buffer *buf, const char *s);
-void mutt_buffer_free(struct Buffer **p);
 void mutt_buffer_from(struct Buffer *buf, char *seed);
 void mutt_buffer_init(struct Buffer *buf);
 void mutt_buffer_deinit(struct Buffer *buf);
